<script type="text/html" data-help-name="dim-xml-rpc in">
  <p>A DIM-XML Server node providing a XML/RPC service.</p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>
      The RPC request received.<br>
      It is a JavaScript object containing the RPC parameters. One possible
      property of this object can be <code>$textContent</code> containing the
      single parameter or the text content of the RPC request.
    </dd>
    <dt class="optional">key<span class="property-type">number</span></dt>
    <dd>
      An optional integer used for matching RPC responses with RPC requests.
    </dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      The RPC response object. This property should not be used directly; it
      will be used by a DIM-XML RPC Response to send the response to the
      client.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a <i>XML/RPC</i> service on a DIM Name
    Server (DNS). A connection to the DNS Server is required for this purpose,
    which can be created by clicking on the pencil icon or selecting an
    existing one shared between several DIM-XML nodes.
  </p>
  <p>
    The service is identified by the <i>Service Name</i> which must be unique
    for a given DNS Server and comply the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>part *( "/" part )</b>
      <br>part = (ALPHA / DIGIT) *body
      <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    For example:
    <pre>/rpc/name/test</pre>
  <p>
    <b>Note</b>: This node does not send any response to the DIM-XML RPC
    Client. The flow must include a <code>DIM-XML RPC Response</code> node to
    complete the RPC request.
  </p>
</script>

<script type="text/html" data-help-name="dim-xml-rpc-response">
  <p>
    A DIM-XML node for sending the RPC service's result back as response to
    requests received from a DIM-XML RPC Input node.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>
      payload
      <span class="property-type">string | number | boolean | object</span>
    </dt>
    <dd>The  RPC's output to be sent back.<br>
      Text content can be attached to the RPC response by adding the
      <code>$textContent</code> property to the input object.<br>
      If this property is not set, no output will be sent.
    </dd>
    <dt class="optional">error<span class="property-type">number</span></dt>
    <dd>
      An optional integer used to reject the RPC request with a given error
      code. If not set, a successful response is sent.
    </dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      This is necessary for sending the response to the client and <b>must</b>
      come from a <code>DIM-XML RPC Input</code> node.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node is meant to return the result of a RPC service invoked by a
    DIM-XML RPC Client, allowing an intermediate processing stage.
  </p>
  <p>
    It must be used in conjunction with a <code>DIM-XML RPC Input</code> node
    since it needs the <code>msg.res</code> property created by the latter in
    order to respond to the requesting client.
  </p>
  <p>
    When an <code>error</code> code is provided as input to this node, the
    <code>payload</code> property should give a description of it.
  </p>
  <p>
    <b>Note</b>: It is <i>RECOMMENDED</i> to map negative <code>error</code>
    numbers to POSIX errno values.
  </p>
</script>
